From 4a91c0445e29aa7895e128d2e9146186d0d90bf8 Mon Sep 17 00:00:00 2001
From: Markus Neuner <neuner.markus@gmx.net>
Date: Wed, 23 Jan 2013 13:17:52 +0100
Subject: [PATCH 2/2] Added Microsoft-specific dllexport and dllimport
 storage-class attributes to export and import
 functions, data, and objects to or from the OROCOS-KDL
 shared libraries (DLL).

The macros and preprocessor defintions that contain the KDL_EXPORT define, which
contains '__declspec(dllexport)' or '__declspec(dllimport)' on windows and
nothing on unix are automatically generated with the CMake function
GENERATE_EXPORT_HEADER() and the accompanying ADD_COMPILER_EXPORT_FLAGS() function.

It generates a 'kdl_export.hpp' in the binary directory that is suitable for
preprocessor inclusion which contains EXPORT macros (SOMELIB_EXPORT,
SOMELIB_NO_EXPORT, SOMELIB_DEPRECATED, SOMELIB_DEPRECATED_EXPORT and
SOMELIB_DEPRECATED_NO_EXPORT) to be used in the OROCOS-KDL library classes.
The resulting hjeader file is included and installed with other headers in the
library.

EXPORTS: All classes and relevant functions in '/orocos_kdl/src/*.hpp', some
constants in '/orocos_kdl/src/utilities/utility.h' and the models in
'/orocos_kdl/models/models.hpp' (if enabled) are exported.

The GENERATE_EXPORT_HEADER function is available since CMake version 2.8.6 and
above. To use the functionality with CMake versions below 2.8.6 (the currently
minumum required CMake version of OROCOS-KDL is 2.4.6) the following files were
added:
  * /orocos_kdl/config/GenerateExportHeader.cmake
  * /orocos_kdl/config/exportheader.cmake.in
  * /orocos_kdl/config/CMakeParseArguments.cmake

FIX: In addions some fixes were applied to convenience the nmake compiler
(missing math.h include and/or missing '#define _USE_MATH_DEFINES', non constant
array length initialization, undefined uint typedef, ambiguous function calls
because of 'using namespace KDL;' e.g. sin, cos, sqrt)
  * /orocos_kdl/examples/geometry.cpp
  * /orocos_kdl/examples/trajectory_example.cpp
  * /orocos_kdl/models/puma560.cpp
  * /orocos_kdl/tests/framestest.cpp
  * /orocos_kdl/tests/kinfamtest.cpp
  * /orocos_kdl/tests/solvertest.cpp

TESTED: Tested that everything compiles (orocos-kdl, orocos-models-kdl, examples,
demos, tests) and that all test succeed and the examples work with the following
compilers:
  * WINDOWS: nmake version 10.00.30319.01 (MSVC 2010) compiled from command line
  * WINDOWS: Visual Studio Express 2010
  * WINDOWS: QtCreator 2.6.1
  * LINUX: gcc version 4.7.2 (Latest Debian unstable as of 2012-12-28)
---
 orocos_kdl/CMakeLists.txt                          |   9 +-
 .../cmakemoduleslegacy/CMakeParseArguments.cmake   | 195 ++++++++++
 .../cmakemoduleslegacy/GenerateExportHeader.cmake  | 408 +++++++++++++++++++++
 orocos_kdl/config/cmakemoduleslegacy/ReadMe.txt    |   1 +
 .../cmakemoduleslegacy/exportheader.cmake.in       |  35 ++
 orocos_kdl/examples/CMakeLists.txt                 |   2 +-
 orocos_kdl/examples/geometry.cpp                   |   3 +
 orocos_kdl/examples/trajectory_example.cpp         |   3 +
 orocos_kdl/models/CMakeLists.txt                   |  11 +-
 orocos_kdl/models/models.hpp                       |  10 +-
 orocos_kdl/models/puma560.cpp                      |   3 +
 orocos_kdl/src/CMakeLists.txt                      |  13 +-
 orocos_kdl/src/articulatedbodyinertia.hpp          |  19 +-
 orocos_kdl/src/chain.hpp                           |   3 +-
 orocos_kdl/src/chaindynparam.hpp                   |   3 +-
 orocos_kdl/src/chainfksolver.hpp                   |  10 +-
 orocos_kdl/src/chainfksolverpos_recursive.hpp      |   3 +-
 orocos_kdl/src/chainfksolvervel_recursive.hpp      |   3 +-
 orocos_kdl/src/chainidsolver.hpp                   |   3 +-
 .../src/chainidsolver_recursive_newton_euler.hpp   |   3 +-
 orocos_kdl/src/chainidsolver_vereshchagin.hpp      |   3 +-
 orocos_kdl/src/chainiksolver.hpp                   |   7 +-
 orocos_kdl/src/chainiksolverpos_lma.hpp            |   3 +-
 orocos_kdl/src/chainiksolverpos_nr.hpp             |   3 +-
 orocos_kdl/src/chainiksolverpos_nr_jl.hpp          |   3 +-
 orocos_kdl/src/chainiksolvervel_pinv.hpp           |   3 +-
 orocos_kdl/src/chainiksolvervel_pinv_givens.hpp    |   3 +-
 orocos_kdl/src/chainiksolvervel_pinv_nso.hpp       |   3 +-
 orocos_kdl/src/chainiksolvervel_wdls.hpp           |   3 +-
 orocos_kdl/src/chainjnttojacsolver.hpp             |   3 +-
 orocos_kdl/src/frameacc.hpp                        | 113 +++---
 orocos_kdl/src/frameacc_io.hpp                     |   9 +-
 orocos_kdl/src/frames.hpp                          | 157 ++++----
 orocos_kdl/src/frames_io.hpp                       |  33 +-
 orocos_kdl/src/framevel.hpp                        | 151 ++++----
 orocos_kdl/src/framevel_io.hpp                     |   9 +-
 orocos_kdl/src/jacobian.hpp                        |  13 +-
 orocos_kdl/src/jntarray.hpp                        |  19 +-
 orocos_kdl/src/jntarrayacc.hpp                     |  31 +-
 orocos_kdl/src/jntarrayvel.hpp                     |  23 +-
 orocos_kdl/src/jntspaceinertiamatrix.hpp           |  19 +-
 orocos_kdl/src/joint.hpp                           |   4 +-
 orocos_kdl/src/kinfam_io.hpp                       |  38 +-
 orocos_kdl/src/path.hpp                            |   7 +-
 orocos_kdl/src/path_circle.hpp                     |   4 +-
 orocos_kdl/src/path_composite.hpp                  |   3 +-
 orocos_kdl/src/path_cyclic_closed.hpp              |   3 +-
 orocos_kdl/src/path_line.hpp                       |   3 +-
 orocos_kdl/src/path_point.hpp                      |   4 +-
 orocos_kdl/src/path_roundedcomposite.hpp           |   3 +-
 orocos_kdl/src/rigidbodyinertia.hpp                |  14 +-
 orocos_kdl/src/rotational_interpolation.hpp        |   3 +-
 orocos_kdl/src/rotational_interpolation_sa.hpp     |   3 +-
 orocos_kdl/src/rotationalinertia.hpp               |  17 +-
 orocos_kdl/src/segment.hpp                         |   3 +-
 orocos_kdl/src/stiffness.hpp                       |   4 +-
 orocos_kdl/src/trajectory.hpp                      |   6 +-
 orocos_kdl/src/trajectory_composite.hpp            |   4 +-
 orocos_kdl/src/trajectory_segment.hpp              |   3 +-
 orocos_kdl/src/trajectory_stationary.hpp           |   3 +-
 orocos_kdl/src/tree.hpp                            |   5 +-
 orocos_kdl/src/treefksolver.hpp                    |   7 +-
 orocos_kdl/src/treefksolverpos_recursive.hpp       |   3 +-
 orocos_kdl/src/treeiksolver.hpp                    |   3 +-
 orocos_kdl/src/treeiksolverpos_nr_jl.hpp           |   3 +-
 orocos_kdl/src/treeiksolverpos_online.hpp          |   3 +-
 orocos_kdl/src/treeiksolvervel_wdls.hpp            |   3 +-
 orocos_kdl/src/treejnttojacsolver.hpp              |   3 +-
 orocos_kdl/src/utilities/utility.h                 |   9 +-
 orocos_kdl/src/velocityprofile.hpp                 |   4 +-
 orocos_kdl/src/velocityprofile_dirac.hpp           |   4 +-
 orocos_kdl/src/velocityprofile_rect.hpp            |   4 +-
 orocos_kdl/src/velocityprofile_spline.hpp          |   3 +-
 orocos_kdl/src/velocityprofile_trap.hpp            |   7 +-
 orocos_kdl/src/velocityprofile_traphalf.hpp        |   6 +-
 orocos_kdl/tests/CMakeLists.txt                    |   2 +-
 orocos_kdl/tests/framestest.cpp                    |  55 +--
 orocos_kdl/tests/kinfamtest.cpp                    |   4 +
 orocos_kdl/tests/solvertest.cpp                    |   4 +-
 79 files changed, 1165 insertions(+), 447 deletions(-)
 create mode 100644 orocos_kdl/config/cmakemoduleslegacy/CMakeParseArguments.cmake
 create mode 100644 orocos_kdl/config/cmakemoduleslegacy/GenerateExportHeader.cmake
 create mode 100644 orocos_kdl/config/cmakemoduleslegacy/ReadMe.txt
 create mode 100644 orocos_kdl/config/cmakemoduleslegacy/exportheader.cmake.in

diff --git a/orocos_kdl/CMakeLists.txt b/orocos_kdl/CMakeLists.txt
index 902a064..37dca90 100644
--- a/orocos_kdl/CMakeLists.txt
+++ b/orocos_kdl/CMakeLists.txt
@@ -52,13 +52,20 @@ INCLUDE_DIRECTORIES(${EIGEN_INCLUDE_DIRS})
 
 INCLUDE (${PROJ_SOURCE_DIR}/config/DependentOption.cmake)
 
+# Add required modules that are not available in older CMake versions
+IF("${CMAKE_VERSION}" VERSION_LESS "2.8.6")
+  SET(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH}" "${CMAKE_CURRENT_SOURCE_DIR}/config/cmakemoduleslegacy")
+ENDIF("${CMAKE_VERSION}" VERSION_LESS "2.8.6")
+
 OPTION(ENABLE_TESTS OFF "Enable building of tests")
 IF( ENABLE_TESTS )
   # If not in standard paths, set CMAKE_xxx_PATH's in environment, eg.
   # export CMAKE_INCLUDE_PATH=/opt/local/include
   # export CMAKE_LIBRARY_PATH=/opt/local/lib
   FIND_LIBRARY(CPPUNIT cppunit)
-  SET(CPPUNIT ${CPPUNIT} "dl")
+  IF( NOT MSVC )
+    SET(CPPUNIT ${CPPUNIT} "dl")
+  ENDIF( NOT MSVC )
   FIND_PATH(CPPUNIT_HEADERS cppunit/TestRunner.h)
   IF ( CPPUNIT AND CPPUNIT_HEADERS)
     MESSAGE("-- Looking for Cppunit - found")
diff --git a/orocos_kdl/config/cmakemoduleslegacy/CMakeParseArguments.cmake b/orocos_kdl/config/cmakemoduleslegacy/CMakeParseArguments.cmake
new file mode 100644
index 0000000..f5a03fe
--- /dev/null
+++ b/orocos_kdl/config/cmakemoduleslegacy/CMakeParseArguments.cmake
@@ -0,0 +1,195 @@
+# CMAKE_PARSE_ARGUMENTS(<prefix> <options> <one_value_keywords> <multi_value_keywords> args...)
+#
+# CMAKE_PARSE_ARGUMENTS() is intended to be used in macros or functions for
+# parsing the arguments given to that macro or function.
+# It processes the arguments and defines a set of variables which hold the
+# values of the respective options.
+#
+# The <options> argument contains all options for the respective macro,
+# i.e. keywords which can be used when calling the macro without any value
+# following, like e.g. the OPTIONAL keyword of the install() command.
+#
+# The <one_value_keywords> argument contains all keywords for this macro
+# which are followed by one value, like e.g. DESTINATION keyword of the
+# install() command.
+#
+# The <multi_value_keywords> argument contains all keywords for this macro
+# which can be followed by more than one value, like e.g. the TARGETS or
+# FILES keywords of the install() command.
+#
+# When done, CMAKE_PARSE_ARGUMENTS() will have defined for each of the
+# keywords listed in <options>, <one_value_keywords> and
+# <multi_value_keywords> a variable composed of the given <prefix>
+# followed by "_" and the name of the respective keyword.
+# These variables will then hold the respective value from the argument list.
+# For the <options> keywords this will be TRUE or FALSE.
+#
+# All remaining arguments are collected in a variable
+# <prefix>_UNPARSED_ARGUMENTS, this can be checked afterwards to see whether
+# your macro was called with unrecognized parameters.
+#
+# As an example here a my_install() macro, which takes similar arguments as the
+# real install() command:
+#
+#   function(MY_INSTALL)
+#     set(options OPTIONAL FAST)
+#     set(oneValueArgs DESTINATION RENAME)
+#     set(multiValueArgs TARGETS CONFIGURATIONS)
+#     cmake_parse_arguments(MY_INSTALL "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN} )
+#     ...
+#
+# Assume my_install() has been called like this:
+#   my_install(TARGETS foo bar DESTINATION bin OPTIONAL blub)
+#
+# After the cmake_parse_arguments() call the macro will have set the following
+# variables:
+#   MY_INSTALL_OPTIONAL = TRUE
+#   MY_INSTALL_FAST = FALSE (this option was not used when calling my_install()
+#   MY_INSTALL_DESTINATION = "bin"
+#   MY_INSTALL_RENAME = "" (was not used)
+#   MY_INSTALL_TARGETS = "foo;bar"
+#   MY_INSTALL_CONFIGURATIONS = "" (was not used)
+#   MY_INSTALL_UNPARSED_ARGUMENTS = "blub" (no value expected after "OPTIONAL"
+#
+# You can the continue and process these variables.
+#
+# Keywords terminate lists of values, e.g. if directly after a one_value_keyword
+# another recognized keyword follows, this is interpreted as the beginning of
+# the new option.
+# E.g. my_install(TARGETS foo DESTINATION OPTIONAL) would result in
+# MY_INSTALL_DESTINATION set to "OPTIONAL", but MY_INSTALL_DESTINATION would
+# be empty and MY_INSTALL_OPTIONAL would be set to TRUE therefor.
+
+#=============================================================================
+# Copyright 2010 Alexander Neundorf <neundorf@kde.org>
+#
+# Distributed under the OSI-approved BSD License (the "License");
+# see accompanying file Copyright.txt for details.
+#
+# This software is distributed WITHOUT ANY WARRANTY; without even the
+# implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+# See the License for more information.
+#=============================================================================
+# (To distribute this file outside of CMake, substitute the full
+#  License text for the above reference.)
+# CMake - Cross Platform Makefile Generator
+# Copyright 2000-2011 Kitware, Inc., Insight Software Consortium
+# All rights reserved.
+# 
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 
+# * Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# 
+# * Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# 
+# * Neither the names of Kitware, Inc., the Insight Software Consortium,
+#   nor the names of their contributors may be used to endorse or promote
+#   products derived from this software without specific prior written
+#   permission.
+
+# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
+# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
+# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
+# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
+# HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
+# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+# 
+# ------------------------------------------------------------------------------
+# 
+# The above copyright and license notice applies to distributions of
+# CMake in source and binary form.  Some source files contain additional
+# notices of original copyright by their contributors; see each source
+# for details.  Third-party software packages supplied with CMake under
+# compatible licenses provide their own copyright notices documented in
+# corresponding subdirectories.
+# 
+# ------------------------------------------------------------------------------
+# 
+# CMake was initially developed by Kitware with the following sponsorship:
+# 
+#  * National Library of Medicine at the National Institutes of Health
+#    as part of the Insight Segmentation and Registration Toolkit (ITK).
+# 
+#  * US National Labs (Los Alamos, Livermore, Sandia) ASC Parallel
+#    Visualization Initiative.
+# 
+#  * National Alliance for Medical Image Computing (NAMIC) is funded by the
+#    National Institutes of Health through the NIH Roadmap for Medical Research,
+#    Grant U54 EB005149.
+# 
+#  * Kitware, Inc.
+# 
+
+
+if(__CMAKE_PARSE_ARGUMENTS_INCLUDED)
+  return()
+endif()
+set(__CMAKE_PARSE_ARGUMENTS_INCLUDED TRUE)
+
+
+function(CMAKE_PARSE_ARGUMENTS prefix _optionNames _singleArgNames _multiArgNames)
+  # first set all result variables to empty/FALSE
+  foreach(arg_name ${_singleArgNames} ${_multiArgNames})
+    set(${prefix}_${arg_name})
+  endforeach(arg_name)
+
+  foreach(option ${_optionNames})
+    set(${prefix}_${option} FALSE)
+  endforeach(option)
+
+  set(${prefix}_UNPARSED_ARGUMENTS)
+
+  set(insideValues FALSE)
+  set(currentArgName)
+
+  # now iterate over all arguments and fill the result variables
+  foreach(currentArg ${ARGN})
+    list(FIND _optionNames "${currentArg}" optionIndex)  # ... then this marks the end of the arguments belonging to this keyword
+    list(FIND _singleArgNames "${currentArg}" singleArgIndex)  # ... then this marks the end of the arguments belonging to this keyword
+    list(FIND _multiArgNames "${currentArg}" multiArgIndex)  # ... then this marks the end of the arguments belonging to this keyword
+
+    if(${optionIndex} EQUAL -1  AND  ${singleArgIndex} EQUAL -1  AND  ${multiArgIndex} EQUAL -1)
+      if(insideValues)
+        if("${insideValues}" STREQUAL "SINGLE")
+          set(${prefix}_${currentArgName} ${currentArg})
+          set(insideValues FALSE)
+        elseif("${insideValues}" STREQUAL "MULTI")
+          list(APPEND ${prefix}_${currentArgName} ${currentArg})
+        endif()
+      else(insideValues)
+        list(APPEND ${prefix}_UNPARSED_ARGUMENTS ${currentArg})
+      endif(insideValues)
+    else()
+      if(NOT ${optionIndex} EQUAL -1)
+        set(${prefix}_${currentArg} TRUE)
+        set(insideValues FALSE)
+      elseif(NOT ${singleArgIndex} EQUAL -1)
+        set(currentArgName ${currentArg})
+        set(${prefix}_${currentArgName})
+        set(insideValues "SINGLE")
+      elseif(NOT ${multiArgIndex} EQUAL -1)
+        set(currentArgName ${currentArg})
+        set(${prefix}_${currentArgName})
+        set(insideValues "MULTI")
+      endif()
+    endif()
+
+  endforeach(currentArg)
+
+  # propagate the result variables to the caller:
+  foreach(arg_name ${_singleArgNames} ${_multiArgNames} ${_optionNames})
+    set(${prefix}_${arg_name}  ${${prefix}_${arg_name}} PARENT_SCOPE)
+  endforeach(arg_name)
+  set(${prefix}_UNPARSED_ARGUMENTS ${${prefix}_UNPARSED_ARGUMENTS} PARENT_SCOPE)
+
+endfunction(CMAKE_PARSE_ARGUMENTS _options _singleArgs _multiArgs)
